/**
* 适当性通用处理类JSSDX
*
* 使用方法：
*
* 1.页面入口函数处，加载JSSDX类
*
*   $.getScript('jssdx_class.js',function(){
*      	//这里可以调用JSSDX对象了。比如：
*				JSSDX.debug=true;//默认此参数为false
*   })
*
* 2.JSSDX支持的方法：
*
*		JSSDX.check(opts,ok_cbk,err_cbk,timeout);
*
*   参数说明：
*			opts		:	参数 {Code:'xxx',Company:'xxx',Remark:'xxx',FeatureId:'xxx'} 参数有则覆盖，没有则默认
*			ok_cbk	:	检查成功后的回调函数
*			err_cbk	:	检查不成功后的回调函数
*   	timeout	:	延迟发送请求 单位：毫秒	
*
* 3.应用示例
*
*   //在提交表单的action里面，加入如下限制
*   JSSDX.check({Code:'600690'},function(){
*			commit();
*   })
*
*/

JSSDX={
	debug:false,
	Code:'',
	Company:'',
      MMBZ:'',
      ZHLE:'',
      GDDM:'',
	Remark:'SDX.CHECK_RISK_PRODUCTCODE,',
	FeatureId:''
}

JSSDX_CheckSdx_Check_OK=function(){
	
}

JSSDX_CheckSdx_Check_ERR=function(){
	
}

JSSDX_Ret_GetFeatureId=function(_fromid,_funid,_flagtype,data){
	if(_funid=='GetFeatureid'){
		JSSDX.debug && alert('GetFeatureid:\r\n'+data);
		JSSDX.FeatureId=data
		if(JSSDX.FeatureId.indexOf('PC.')!=0){
			JSSDX.FeatureId='PC.'+JSSDX.FeatureId
		}
		JSSDX.checkSdx()
	}
}

JSSDX_Ret_CheckSdx=function(_fromid,_funid,_flagtype,data){
	if(_funid=='CheckSdx'){
		JSSDX.debug && alert('CheckSdx:\r\n'+data);
		JSSDX.Sdx=data
		if(JSSDX.Sdx=='0'){
			JSSDX_CheckSdx_Check_OK()
		}
		else{
			JSSDX_CheckSdx_Check_ERR()
		}
	}
}

JSSDX.getFeatureId=function(){
	JSSDX.debug && alert('send GetFeatureid');
	window.external.TDX_SENDDATA("JSSDX_Ret_GetFeatureId", "GetFeatureid", '[{}]', '');
}

JSSDX.checkSdx=function(){
	var keys=[JSSDX.Code,JSSDX.Company,JSSDX.Remark,JSSDX.FeatureId,JSSDX.MMBZ,JSSDX.ZHLE,JSSDX.GDDM].join('{T}')
	var params='[{"F149":"'+keys+'"}]';
	JSSDX.debug && alert('CheckSdx-Params:\r\n'+params);
	window.external.TDX_SENDDATA("JSSDX_Ret_CheckSdx", "CheckSdx", params , '');
}

JSSDX.check=function(opts,ok_cbk,err_cbk,timeout){
	
	opts=opts||{}
	
	if(opts.Debug){
		JSSDX.debug=opts.Debug;
	}
	if(opts.Code){
		JSSDX.Code=opts.Code;
	}
	if(opts.Company){
		JSSDX.Company=opts.Company;
	}
	if(opts.Remark){
		JSSDX.Remark=opts.Remark;
	}
	if(opts.FeatureId){
		JSSDX.FeatureId=opts.FeatureId;
	}
     	if(opts.MMBZ){
		JSSDX.MMBZ=opts.MMBZ;
	}
      if(opts.ZHLE){
		JSSDX.ZHLE=opts.ZHLE;
	}
	if(opts.GDDM){
		JSSDX.GDDM=opts.GDDM;
	}
	
	if(JSSDX.debug){
		window.onerror=function(sMessage,sUrl,sLine){
			alert(['错误信息：'+sMessage,'文件路径：'+sUrl,'行号：'+sLine].join('\r\n'))
		}
	}
	
	ok_cbk && (JSSDX_CheckSdx_Check_OK=ok_cbk);
	err_cbk && (JSSDX_CheckSdx_Check_ERR=err_cbk);
	
	setTimeout(function(){
		JSSDX.debug && alert('Start');
		JSSDX.getFeatureId()
	},timeout||10)
}
